/* DO.CMD - Aaron Bell Dec 97                                     */
/*  written : Dec 97                                               */
/*  modified: Jun 98 - added %n and %e, much more powerful now :) */

filemode = 0    /* create file? boolean */

parse arg op cmd

IF pos('*',op) <> 0 THEN DO
   say
   say 'Sorry, wildcards are only supported as arguments.'
   exit 1
END
/* IF (cmd = '') | (pos('*',cmd) = 0) | (translate(op) = '/F') THEN call help */

IF (cmd = '') | (pos('*',cmd) = 0) THEN call help
IF (translate(op) = '/F') THEN DO
  say 'Usage: /F=<cmd name>'
  exit
END

IF abbrev(translate(op),'/F=') = 1 THEN DO
   file = delstr(op,1,3)
   IF file = '' THEN DO
      say
      say 'Error in parameter /F= : file expected.'
      exit -1
   END
   ELSE IF pos('.',file) = 0 THEN file = file || '.cmd'
   filemode = 1
   say 'Creating file:' file
   rc = stream(file,'c','OPEN WRITE')
   rc = lineout(file,'/* Created by DO.CMD */')
END
ELSE cmd = op cmd       /* op wasn't a parameter, so add it to cmd */

wildcard = ''
DO i = 1 to words(cmd) UNTIL wildcard <> ''
   IF pos('*',word(cmd,i)) <> 0 THEN wildcard = word(cmd,i)
END

parse var cmd cmd_pre (wildcard) cmd_post

call rxfuncadd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
call sysloadfuncs

rc = SysfileTree(wildcard,'file.','FO')

IF file.0 = 0 THEN DO
   say
   say 'No matches found for:' wildcard
   IF filemode = 1 THEN rc = stream(file,'c','CLOSE')
   exit 1
END
ELSE DO
   DO i = 1 to file.0
      command = space(cmd_pre file.i cmd_post)

      numdots = countstr('.',file.i)
      IF numdots > 1 THEN DO
        say "Error! More than one dot in path '"file.i"'"
        exit -1
      END

      parse var file.i fname '.' fext

      lastslash = lastpos('\',fname)
      fname = substr(fname,lastslash+1)

      command = changestr('%n',command,fname)
      command = changestr('%e',command,fext)

      IF filemode = 1 THEN rc = lineout(file,"'@call" command"'")
      ELSE DO
         '@call' command   /* do it */
         IF rc = 1041 THEN DO
            say
            say 'Slight error there: unknown command.'
            IF filemode = 1 THEN rc = stream(file,'c','CLOSE')
            exit -1
         END
      END
   END
END

IF filemode = 1 THEN rc = stream(file,'c','CLOSE')
exit 0
/*----- Procedures ----------------------------------------------------------*/
help:
   say
   say 'Usage: DO [options] <command> <args>'
   say
   say 'Options:'
   say '     /F=<file> : create <file>.cmd, an equivalent REXX program.'
   say
   say 'Escape codes:'
   say '     %n in an argument will be replaced by the file name'
   say '     %e in an argument will be replaced by the file extension'
   say
   say 'Examples:'
   say '     DO edit *.txt                   edit all text files'
   say '     DO copy *.java %n.old           backup all java files'
   say '     DO ren oldName.* newName.%e     change the name of a number of file types'
   exit 0
return
