// ------------------------------------------------------------------------
// Call ECI List Systems  (part of the ECIJGATE suite)
//                        (Alan Hollingshead - April 1998)
// ------------------------------------------------------------------------

package jgtest.util;

import ibm.cics.jgate.client.*;

public class ECIlist
{
   // ------------------------------------------------------------------------
   // Method: allSystems
   // List all systems available
   // ------------------------------------------------------------------------
   public static void allSystems(JavaGateway jgaConnection)
   {
      int iTotalSystems;
      ECIRequest eciRequest = null;
      eciRequest = ECIRequest.listSystems(99);
      try
      {
         jgaConnection.flow(eciRequest);

         iTotalSystems = (eciRequest.SystemList.size()/2);

         System.out.println("\nServers available: ");

         if (eciRequest.getRc() == 0)
         {
             for (int iSysLoop = 0, iSysNum = 1;
                      iSysLoop < eciRequest.SystemList.size();
                      iSysLoop += 2,
                      iSysNum  += 1)
             {

                System.out.println("     Server ("+iSysNum+") " +
                      (String) eciRequest.SystemList.elementAt(iSysLoop) +
                      ", Description: " +
                      (String) eciRequest.SystemList.elementAt(iSysLoop + 1));
             }
         }
         else
         {
            System.out.println("ECIRequest.listSystems failed with Rc : " +
                        eciRequest.getRc());
            return;
         }
      }
      catch (Exception e)
      {
         T.ln(null,"ERROR: Caught Exception: ");
         T.ex(null,e);
         System.out.println("\n--- Error during JavaGateway connection ---\n");
         System.out.println("--- Caught Exception: " + e);
      }
   }
   // ------------------------------------------------------------------------
   // Method: getServer1
   // If server name has not been provided, get the server name
   // ------------------------------------------------------------------------
   public static String getServer1(JavaGateway jgaConnection)
   {
      ECIRequest eciRequest = ECIRequest.listSystems(1);
      try
      {
         jgaConnection.flow(eciRequest);
      }
      catch (Exception e) {
         System.out.println("\n--- ERROR during flow of listSystems(1) request ---");
         System.exit(0);
      }
      // output info
      System.out.println("\n--- Using CICS Region: "+ eciRequest.SystemList.elementAt(0));
      return (String) eciRequest.SystemList.elementAt(0);
   }
}
