// ------------------------------------------------------------------------
// Call EPI List Systems  (part of the EPIJGATE suite)
//                        (Alan Hollingshead - April 1998)
// ------------------------------------------------------------------------

package jgtest.util;

import ibm.cics.jgate.client.*;

public class EPIlist
{
   // ------------------------------------------------------------------------
   // Method: allSystems
   // List all systems available
   // ------------------------------------------------------------------------
   public static void allSystems(JavaGateway jgaConnection)
   {
      int iTotalSystems;
      EPIRequest epiRequest = null;
      epiRequest = EPIRequest.listSystems(99);
      try
      {
         jgaConnection.flow(epiRequest);

         iTotalSystems = (epiRequest.SystemList.size()/2);

         System.out.println("\nServers available: ");

         if (epiRequest.getRc() == 0)
         {
             for (int iSysLoop = 0, iSysNum = 1;
                      iSysLoop < epiRequest.SystemList.size();
                      iSysLoop += 2,
                      iSysNum  += 1)
             {

                System.out.println("     Server ("+iSysNum+") " +
                      (String) epiRequest.SystemList.elementAt(iSysLoop) +
                      ", Description: " +
                      (String) epiRequest.SystemList.elementAt(iSysLoop + 1));
             }
         }
         else
         {
            System.out.println("EPIRequest.listSystems failed with Rc : " +
                        epiRequest.getRc());
            return;
         }
      }
      catch (Exception e)
      {
         T.ln(null,"ERROR: Caught Exception: ");
         T.ex(null,e);
         System.out.println("\n--- Error during JavaGateway connection ---\n");
         System.out.println("--- Caught Exception: " + e);
      }
   }
   // ------------------------------------------------------------------------
   // Method: getServer1
   // If server name has not been provided, get the server name
   // ------------------------------------------------------------------------
   public static String getServer1(JavaGateway jgaConnection)
   {
      EPIRequest epiRequest = EPIRequest.listSystems(1);
      try
      {
         jgaConnection.flow(epiRequest);
      }
      catch (Exception e) {
         System.out.println("\n--- ERROR during flow of listSystems(1) request ---");
         System.exit(0);
      }
      // output info
      System.out.println("\n--- Using CICS Region: "+ epiRequest.SystemList.elementAt(0));
      return (String) epiRequest.SystemList.elementAt(0);
   }
}
