// ------------------------------------------------------------------------
// Close connection to JGate, then terminate   (part of the ECIJGATE suite)
//                                         (Alan Hollingshead - April 1998)
// Updated : Jun 1998 - createSecureJGate (Aaron Bell)
// ------------------------------------------------------------------------

package jgtest.util;

import ibm.cics.jgate.client.*;

public class setJGate
{
   // ------------------------------------------------------------------------
   // Method: createJGate
   // Create connection to JGate, returning jgaConnection object
   // ------------------------------------------------------------------------
   public static JavaGateway createJGate(inputParms theParms)
   {
      JavaGateway jgaConnection = null;
      try
      {
         jgaConnection = new JavaGateway(theParms.sJGate, theParms.iPort);
         System.out.println("\n--- Successfully created JavaGateway connection ---");
      }
      catch (Exception e)
      {
         T.ln(null,"ERROR: Caught Exception: ");
         T.ex(null,e);
         System.out.println("\n--- Failed to create JavaGateway connection ---");
         System.out.println("--- Caught Exception: " + e);
         System.exit(0);
      }
      return jgaConnection;
   }

   // ------------------------------------------------------------------------
   // Method: createSecureJGate
   // Create secure connection to JGate, returning jgaConnection object
   // ------------------------------------------------------------------------
   public static JavaGateway createSecureJGate(inputParms theParms)
   {
      JavaGateway jgaConnection = null;
      try
      {
         jgaConnection = new JavaGateway(theParms.sJGate, theParms.iPort,
                                         theParms.sClientSecurity,
                                         theParms.sServerSecurity);
         System.out.println("\n--- Successfully created Secure JavaGateway connection ---");
      }
      catch (Exception e)
      {
         T.ln(null,"ERROR: Caught Exception: ");
         T.ex(null,e);
         System.out.println("\n--- Failed to create Secure JavaGateway connection ---");
         System.out.println("--- Caught Exception: " + e);
         System.exit(0);
      }
      return jgaConnection;
   }

   // ------------------------------------------------------------------------
   // Method: closeJGate
   // Close connection to JGate, then terminate.
   // ------------------------------------------------------------------------

   public static void closeJGate(JavaGateway jgaConnection)
   {
      try
      {
         jgaConnection.close();
         System.out.println("\n--- Successfully closed JavaGateway connection ---");
      }
      catch (Exception e)
      {
         T.ln(null,"ERROR: Caught Exception: ");
         T.ex(null,e);
         System.out.println("\n--- Error closing JavaGateway connection ---\n");
         System.out.println("--- Caught Exception: " + e);
         System.exit(0);
      }
   }
}
